/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * e:/builds/moz2_slave/mozilla-central-win32-xulrunner/build/accessible/public/nsIAccessibleDocument.idl
 */

package org.mozilla.interfaces;

/**
 * An interface for in-process accessibility clients
 * that wish to retrieve information about a document.
 * When accessibility is turned on in Gecko,
 * there is an nsIAccessibleDocument for each document
 * whether it is XUL, HTML or whatever.
 * You can QueryInterface to nsIAccessibleDocument from
 * the nsIAccessible or nsIAccessNode for the root node
 * of a document. You can also get one from 
 * nsIAccessNode::GetAccessibleDocument() or 
 * nsIAccessibleEvent::GetAccessibleDocument()
 *
 * @status UNDER_REVIEW
 */
public interface nsIAccessibleDocument extends nsISupports {

  String NS_IACCESSIBLEDOCUMENT_IID =
    "{03c6ce8a-aa40-4484-9282-e6579c56e054}";

  /**
   * The URL of the document
   */
  String getURL();

  /**
   * The title of the document, as specified in the document.
   */
  String getTitle();

  /**
   * The mime type of the document
   */
  String getMimeType();

  /**
   * The doc type of the document, as specified in the document.
   */
  String getDocType();

  /**
   * The nsIDOMDocument interface associated with this document.
   */
  nsIDOMDocument getDOMDocument();

  /**
   * The nsIDOMWindow that the document resides in.
   */
  nsIDOMWindow getWindow();

  /**
   * The namespace for each ID that is handed back.
   */
  String getNameSpaceURIForID(short nameSpaceID);

}