/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * e:/builds/moz2_slave/mozilla-central-win32-xulrunner/build/netwerk/protocol/http/nsIHttpAuthenticableChannel.idl
 */

package org.mozilla.interfaces;

public interface nsIHttpAuthenticableChannel extends nsIProxiedChannel {

  String NS_IHTTPAUTHENTICABLECHANNEL_IID =
    "{701093ac-5c7f-429c-99e3-423b041fccb4}";

  /**
     * If the channel being authenticated is using SSL.
     */
  boolean getIsSSL();

  /**
     * Returns if the proxy HTTP method used is CONNECT. If no proxy is being
     * used it must return PR_FALSE.
     */
  boolean getProxyMethodIsConnect();

  /**
     * Cancels the current request. See nsIRequest.
     */
  void cancel(long aStatus);

  /**
     * The load flags of this request. See nsIRequest.
     */
  long getLoadFlags();

  /**
     * The URI corresponding to the channel. See nsIChannel.
     */
  nsIURI getURI();

  /**
     * The load group of this request. It is here for querying its
     * notificationCallbacks. See nsIRequest.
     */
  nsILoadGroup getLoadGroup();

  /**
     * The notification callbacks for the channel. See nsIChannel.
     */
  nsIInterfaceRequestor getNotificationCallbacks();

  /**
     * The HTTP request method. See nsIHttpChannel.
     */
  String getRequestMethod();

  /**
     * The "Server" response header.
     * Return NS_ERROR_NOT_AVAILABLE if not available.
     */
  String getServerResponseHeader();

  /**
     * The Proxy-Authenticate response header.
     */
  String getProxyChallenges();

  /**
     * The WWW-Authenticate response header.
     */
  String getWWWChallenges();

  /**
     * Sets the Proxy-Authorization request header. An empty string 
     * will clear it.
     */
  void setProxyCredentials(String credentials);

  /**
     * Sets the Authorization request header. An empty string
     * will clear it.
     */
  void setWWWCredentials(String credentials);

  /**
     * Called when authentication information is ready and has been set on this
     * object using setWWWCredentials/setProxyCredentials. Implementations can
     * continue with the request and send the given information to the server.
     *
     * It is called asynchronously from
     * nsIHttpChannelAuthProvider::processAuthentication if that method returns
     * NS_ERROR_IN_PROGRESS.
     *
     * @note  Any exceptions thrown from this method should be ignored.
     */
  void onAuthAvailable();

  /**
     * Notifies that the prompt was cancelled. It is called asynchronously
     * from nsIHttpChannelAuthProvider::processAuthentication if that method
     * returns NS_ERROR_IN_PROGRESS.
     *
     * @param userCancel
     *        If the user was cancelled has cancelled the authentication prompt.
     */
  void onAuthCancelled(boolean userCancel);

}